from random import randint, seed, shuffle
from string import ascii_lowercase as abc
seed(47)

def save(fname, K, strom_po_riadkoch, queries):
    f = open(fname, 'w')
    print( K, queries, file=f )
    N = 2**(K+1) - 1
    assert len(strom_po_riadkoch) == N
    rodic = [ 0 for _ in range(N+1) ]
    for n in range(1,N):
        u = strom_po_riadkoch[n]
        v = strom_po_riadkoch[(n-1)//2]
        rodic[u] = v
    print(*rodic[1:], file=f)
    f.close()

save('00.sample.a.in', 1, [3,1,2], 250000 )
save('00.sample.b.in', 3, [9,5,2,11,15,12,3,7,4,1,13,14,6,8,10], 250000 )

LIMITS = [ None, 250000, 50000, 100000, 800000, 500000 ]
BATCHCOUNT = [ 0 for _ in range(6) ]

def addtest(batch, size, strom_po_riadkoch):
    b = BATCHCOUNT[batch]
    BATCHCOUNT[batch] += 1
    fname = f'{batch:02d}.{abc[b]}.in'
    save(fname, size, strom_po_riadkoch, LIMITS[batch])

def addtests(batch, size, count_random=1):
    addtest(batch, size, list(range(1,2**(size+1))))
    addtest(batch, size, list(reversed(range(1,2**(size+1)))))
    for i in range(count_random):
        strom = list(range(1,2**(size+1)))
        shuffle(strom)
        addtest(batch, size, strom)

addtests(1, 1)
addtests(1, 2)
addtests(1, 5, 2)

addtests(2, 4)
addtests(2, 5, 5)

addtests(3, 5)
addtests(3, 6, 5)

addtests(4, 9, 3)
addtests(4, 10, 3)

addtests(5, 10, 4)
addtests(5, 11, 4)

